;**************************************************************************
;*
;* FILE  loader.asm
;* Copyright (c) 2005, 2006 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: loader.asm,v 1.15 2006-10-20 20:55:16 tlr Exp $
;*
;* DESCRIPTION
;*   load and install dtvtrans.
;*
;******
	processor 6502


	MAC	sac
	dc.b	$32,{1}
	ENDM
	MAC	sir
	dc.b	$42,{1}
	ENDM

	seg	code
	org	$0801
;**************************************************************************
;*
;* Basic line!
;*
;******
StartOfFile:
	dc.w	EndLine
	dc.w	0
	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
EndLine:
	dc.w	0
SysAddress1:
	jmp	SysAddress

start_head:
	include	"config.asm"
end_conf:
start_conf	equ	start_head+HEADER_LEN
start_conf_mon	equ	$800b+HEADER_LEN
	
;**************************************************************************
;*
;* SysAddress... When run we will enter here!
;*
;******
SysAddress:

; install the server
	sei

; restore sysline (if we were newed)
	lda	#<EndLine
	sta	$0801
	lda	#>EndLine
	sta	$0802

sa_sm1:
	bit	trampoline
	lda	#$4c
	sta	sa_sm1

	sir	$e9
; map $018000 at $8000-$c000
	ldy	#$06
; skip + burst
	ldx	#%00000011
	sir	$12
	
	lda	#1
	sta	$d03f
	lda	#%00100000
	sta	$d03c

	jsr	exod_decrunch

	ldx	#end_conf-start_conf-1
sa_lp2:
	lda	start_conf,x
	sta	start_conf_mon,x
	dex
	bpl	sa_lp2

	lda	#%00000000
	sta	$d03c
	sta	$d03f
	sir	$e9
; map $008000 at $8000-$c000
	ldy	#$02
; no skip or burst
	tax
	sir	$12

; install a couple of trampolines.
	ldy	#trampoline_end-trampoline-1
sa_lp3:
	lda	trampoline,y
	sta	$cf08,y		; 53000
	sta	$2bc,y		; 700
	dey
	bpl	sa_lp3
	cli
; print compressed Y=$ff
	bne	prt_skp1
prt_lp1:
	tax
	jsr	prt_get
prt_lp2:
	jsr	$ffd2
	dex
	bne	prt_lp2
prt_skp1:
	ldx	#$01
	jsr	prt_get
	bne	prt_lp2
	jsr	prt_get
	bne	prt_lp1
	jmp	$a474		; return to basic
prt_get:
	iny
	bne	prt_skp2
	inc	prt_sm1+2
prt_skp2:
prt_sm1:
	lda	start_msg-$0100,y
	rts

start_msg:
	dc.b	147,142		; Cls, uppercase
	incbin	"starttext.pck"
	dc.b	0

trampoline:
	sei
	sac	$dd
	tax
	lda	#$06
	jmp	($4009)
trampoline_end:

code_start:
	incbin	"server.exo"
code_end:

	include	"exodecrunch.asm"
exod_get_crunched_byte:
	lda	opbase + 1
	bne	nowrap
	dec	opbase + 2
nowrap:	dec	opbase + 1
	;; change the $ffff to point to the byte immediately following the last
	;; byte of the crunched file data (mem command)
opbase:	lda	code_end
	rts
seg_end:
	seg.u	bss
	org	seg_end
exod_decrunch_table:
	ds.b	156
; eof
