##########################################################################
#
# FILE  common.mk
# Copyright (c) 2004, 2005 Daniel Kahlin <daniel@kahlin.net>
# Written by Daniel Kahlin <daniel@kahlin.net>
# $Id: common.mk,v 1.3 2006-11-26 21:50:53 tlr Exp $
#
# DESCRIPTION
#   Common Makefile definitions.
#   Include this after setting the relative path to this directory
#   in the PACKAGE_ROOT variable.
#
#   i.e (for a subdirectory to this directory):
#       SUBDIRS=subdir1 subdir2 subdir3
#
#       PACKAGE_ROOT=..
#       include $(PACKAGE_ROOT)/common.mk
#
#   The standard targets supported are:
#
#     all::    build all target binaries.
#
#     doc::    build all documentation.
#
#     clean::  clean all objects, temporaries and target binaries
#
#     distclean:: normal clean + remove files created by configure 
#
######
include $(PACKAGE_ROOT)/package.mk

##############################################################################
#
# DESCRIPTION
#   standard targets, these may be enhanced by appending in the actual
#   Makefile.
#
#######
all::	subdirs

doc::	subdirs

# default clean rules.
clean::	subdirs
	rm -f *~ \#*\#

# default distclean rules
distclean::	clean

subdirs::
ifneq ($(SUBDIRS),)
	for dir in $(SUBDIRS); do \
	    $(MAKE) -C $${dir} $(MAKECMDGOALS); \
	done
endif


# eof
