/*************************************************************************
 *
 * FILE  timer.hpp
 * Copyright (c) 2005, 2006 Daniel Kahlin <daniel@kahlin.net>
 * Copyright (c) 2006, 2007 Hannu Nuotio <hannu.nuotio@pp.inet.fi>
 * Written by Daniel Kahlin <daniel@kahlin.net> &
 *            Hannu Nuotio <hannu.nuotio@pp.inet.fi>
 * $Id: timer.hpp,v 1.6 2007-01-02 18:45:34 tlr Exp $
 *
 * DESCRIPTION
 *   Template for C++ header files.
 *
 ******/
#ifndef TIMER_HPP
#define TIMER_HPP

#include "../util/types.hpp"
#include <sys/time.h>
#include <time.h>
#include <errno.h>

/*************************************************************************
 *
 * CLASS  Timer
 *
 * DESCRIPTION
 *
 * KNOWN BUGS
 *   none
 *
 ******/
class Timer
{
public:
    Timer() {}
    void start() { gettimeofday(&start_, NULL); }    
    void stop() { gettimeofday(&stop_, NULL); }    
    uint32_t get_time() const { return (stop_.tv_sec - start_.tv_sec)*1000+(stop_.tv_usec - start_.tv_usec)/1000; }
    double get_time_d() const { return (double)get_time()/1000; }

private:
    timeval start_;
    timeval stop_;
};


class USleep
{
public:
    USleep() {}

    static void usleep(int t)
    {
    timeval ts;
    uint32_t stop, cur;
    
    gettimeofday(&ts, NULL);
    cur = ts.tv_sec*1000000+ts.tv_usec;
    stop = cur + t;

    while (cur<stop) {
       gettimeofday(&ts, NULL);
       cur = ts.tv_sec*1000000+ts.tv_usec;
       }
    }
};


#endif /* TIMER_HPP */

/* eof */
